#!/bin/sh
mount_path="/mnt"
mnt_exist=`mount | grep "${mount_path}"`

rm -f /etc/gofactory
rm -rf /mnt2/gofactory
sync

. /img/bin/functions
    
if [ "${mnt_exist}" == "" ];then
    usb=`cat /proc/scsi/scsi | grep "Intf:USB" | cut -d":" -f4 | cut -d" " -f1`
    mount "/dev/${usb}1" ${mount_path}
fi

get_plugged_devices() {
        local _max_tray=0
        local _dev=""

        if [ ! -f /proc/thecus_io ]; then
            _max_tray=0
        else
            _max_tray=`cat /proc/thecus_io | awk '/MAX_TRAY/{print $2}'`
        fi

        for((i=1;i<=${_max_tray};i++))
        do
            _dev=`cat /proc/scsi/scsi | grep "Tray:$i Disk:" | cut -d":" -f4 | cut -d" " -f1`
            if [ "${_dev}" != "" ]; then
                if [ ${devs_num} -eq 0 ]; then
                    devices="${_dev}"
                else
                    devices="${devices} ${_dev}"
                fi
                devs_num=$(($devs_num+1))
            fi
        done
}

DO_ACT(){
    devs_num=0
    devices=""
    get_plugged_devices
    
    echo "###############################"
    echo "# Normal booting"
    echo "###############################"
    # check if each runtime system partition is RAID1
    i=1
    for dev in ${devices}
    do
            devs[$i]="${dev}"
            is_raid1[$i]=0
            uuid[$i]=`get_uuid ${devs[$i]} ${rootfs_partnum}`
            if [ "${uuid[$i]}" != "" ]; then
                    echo "${uuid[$i]}" | grep "^raid1;"
                    if [ $? -eq 0 ]; then   # sd? runtime system is RAID1
                            is_raid1[$i]=1
                    fi
            fi
            i=$(($i+1))
    done
    
    # check which will be used in runtime system
    rootfs_devs=""
    rootfs_uuid=""
    for((i=1;i<=${devs_num};i++))
    do
            if [ ${is_raid1[$i]} -eq 1 ]; then
                    if [ "${rootfs_uuid}" = "" ]; then
                            rootfs_uuid="${uuid[$i]}"
                            rootfs_devs="${devs[$i]}"
                    else
                            if [ "${uuid[$i]}" = "${rootfs_uuid}" ]; then
                                    rootfs_devs="${rootfs_devs} ${devs[$i]}"
                            fi
                    fi
            fi
    done
    
    #  assemble rootfs RAID
    sh /img/bin/assemble_rootfs.sh "${rootfs_devs}"
    
    if [ -f "/sysroot/etc/.rootfs_rpm" ];then
        rm -f /sysroot/etc/.rootfs_rpm
    fi
    
    mount /dev/mmcblk0p3 /mnt/
    rm -rf /mnt/*

    sync
    umount /mnt
    umount /sysroot
    mdadm -S /dev/md70
    
    /img/bin/pic.sh LCM_MSG "Clean OS Flag" "Finish"
    
    echo "Buzzer 1" > /proc/thecus_io
    sleep 3
    echo "Buzzer 0" > /proc/thecus_io
    
    poweroff -f
}

Check_FAC(){
    if [ -f ${mount_path}/THECUS.N1600.FAC ];then
        if [ -f ${mount_path}/THECUS.N1600.FAC.md5 ];then
            if [ -f ${mount_path}/THECUS.N1600.PATCH ];then
                return 0
            fi
        fi
    fi
    return 1
}

if [ "${front_1}" = "" ]; then
    DO_ACT
    exit
else
  umask 000
  for j in ${front_1}
  do
    instant=`mount |grep "$j" | cut -d"/" -f6 | cut -d" " -f1 | sed -n '1p'`
    mount_path="/raid/USBHDD/${instant}/1"
    Check_FAC
    if [ "$?" = "0" ];then
      DO_ACT
      exit
    fi
  done
fi
